//+------------------------------------------------------------------+
//|                               My_Currency_Strength_Indicator.mq4 |
//|                                               Erick_Fenstermaker |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Erick_Fenstermaker"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

//Opening a separate window and setting the parameters of the window extents
#property indicator_separate_window
#property indicator_maximum 20000
#property indicator_minimum -20000
#property indicator_level1 40
#property indicator_level2 1.75
#property indicator_level3 -1.75

//Setting up the memory allocation and default settings for the indicator lines
#property indicator_buffers 50
#property indicator_color1 clrPurple
#property indicator_color2 clrRed
#property indicator_color3 clrOrange
#property indicator_color4 clrWhite
#property indicator_color5 clrBlue
#property indicator_color6 clrGreen
#property indicator_color7 clrLightBlue
#property indicator_color8 clrYellow

//Setting up the memory allocation and default settings for the arrows
#property indicator_color9 clrPurple
#property indicator_color10 clrPurple

//setting width of lines
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2

//setting width of arrows
#property indicator_width9 1
#property indicator_width10 1

//settings for stochastic lines
extern int Kperiod = 5;
extern int Dperiod = 3;
extern int Slowing = 3;
extern ENUM_MA_METHOD method = MODE_SMA;

//Declaring the arrays that will draw the lines for the indicator
double EUR_Band[];
double EUR_UpArrow[];
double EUR_DownArrow[];
double GBP_Band[];
double AUD_Band[];
double NZD_Band[];
double USD_Band[];
double CAD_Band[];
double CHF_Band[];
double JPY_Band[];


//double perEUR = 0;
//double perGBP = 0;
//double perAUD = 0;
//double perNZD = 0;
//double perUSD = 0;
//double perCAD = 0;
//double perCHF = 0;
//double perJPY = 0;

//Array buffers for arrows
//double uparrow[];
//double downarrow[];

//Sets how far you look into the past (15 min incremints 4 = 1hr)
int lookBack = 16 + 1;
int timeframe = PERIOD_M15;

//sets how far aprt single currency strengths should be before taking action
//set to a low number for testing. this should give a true result
double gap = 1;


//All this commented stuff has moved to the My_CSI_Arrow_Calculator.mql file
//this is all used in creating the custom value I need from each candle
//to draw the curency strength lines
//+------------------------------------------------------------------+
//|           Gathers the open and current price info                |
//+------------------------------------------------------------------+

////Gathers the EUR Symbol close values from the past   
//double lookBackEURGBP = iClose("EURGBP",timeframe,lookBack);
//double lookBackEURAUD = iClose("EURAUD",timeframe,lookBack);
//double lookBackEURNZD = iClose("EURNZD",timeframe,lookBack);
//double lookBackEURUSD = iClose("EURUSD",timeframe,lookBack);
//double lookBackEURCAD = iClose("EURCAD",timeframe,lookBack);
//double lookBackEURCHF = iClose("EURCHF",timeframe,lookBack);
//double lookBackEURJPY = iClose("EURJPY",timeframe,lookBack);
////Gathers the GBP Symbol close values from the past   
//double lookBackGBPAUD = iClose("GBPAUD",timeframe,lookBack);
//double lookBackGBPNZD = iClose("GBPNZD",timeframe,lookBack);
//double lookBackGBPUSD = iClose("GBPUSD",timeframe,lookBack);
//double lookBackGBPCAD = iClose("GBPCAD",timeframe,lookBack);
//double lookBackGBPCHF = iClose("GBPCHF",timeframe,lookBack);
//double lookBackGBPJPY = iClose("GBPJPY",timeframe,lookBack);
////Gathers the AUD Symbol close values from the past   
//double lookBackAUDNZD = iClose("AUDNZD",timeframe,lookBack);
//double lookBackAUDUSD = iClose("AUDUSD",timeframe,lookBack);
//double lookBackAUDCAD = iClose("AUDCAD",timeframe,lookBack);
//double lookBackAUDCHF = iClose("AUDCHF",timeframe,lookBack);
//double lookBackAUDJPY = iClose("AUDJPY",timeframe,lookBack);
////Gathers the NZD Symbol close values from the past   
//double lookBackNZDUSD = iClose("NZDUSD",timeframe,lookBack);
//double lookBackNZDCAD = iClose("NZDCAD",timeframe,lookBack);
//double lookBackNZDCHF = iClose("NZDCHF",timeframe,lookBack);
//double lookBackNZDJPY = iClose("NZDJPY",timeframe,lookBack);
////Gathers the USD Symbol close values from the past   
//double lookBackUSDCAD = iClose("USDCAD",timeframe,lookBack);
//double lookBackUSDCHF = iClose("USDCHF",timeframe,lookBack);
//double lookBackUSDJPY = iClose("USDJPY",timeframe,lookBack);
////Gathers the CAD Symbol close values from the past   
//double lookBackCADCHF = iClose("CADCHF",timeframe,lookBack);
//double lookBackCADJPY = iClose("CADJPY",timeframe,lookBack);
////Gathers the CHF Symbol close values from the past   
//double lookBackCHFJPY = iClose("CHFJPY",timeframe,lookBack);
//
////Gathers the current EUR Symbol Ask Values
//double EURGBP = SymbolInfoDouble("EURGBP", SYMBOL_ASK);
//double EURAUD = SymbolInfoDouble("EURAUD", SYMBOL_ASK);
//double EURNZD = SymbolInfoDouble("EURNZD", SYMBOL_ASK);
//double EURUSD = SymbolInfoDouble("EURUSD", SYMBOL_ASK);
//double EURCAD = SymbolInfoDouble("EURCAD", SYMBOL_ASK);
//double EURCHF = SymbolInfoDouble("EURCHF", SYMBOL_ASK);
//double EURJPY = SymbolInfoDouble("EURJPY", SYMBOL_ASK);
////Gathers the current GBP Symbol Ask Values
//double GBPAUD = SymbolInfoDouble("GBPAUD", SYMBOL_ASK);
//double GBPNZD = SymbolInfoDouble("GBPNZD", SYMBOL_ASK);
//double GBPUSD = SymbolInfoDouble("GBPUSD", SYMBOL_ASK);
//double GBPCAD = SymbolInfoDouble("GBPCAD", SYMBOL_ASK);
//double GBPCHF = SymbolInfoDouble("GBPCHF", SYMBOL_ASK);
//double GBPJPY = SymbolInfoDouble("GBPJPY", SYMBOL_ASK);
////Gathers the current AUD Symbol Ask Values
//double AUDNZD = SymbolInfoDouble("AUDNZD", SYMBOL_ASK);
//double AUDUSD = SymbolInfoDouble("AUDUSD", SYMBOL_ASK);
//double AUDCAD = SymbolInfoDouble("AUDCAD", SYMBOL_ASK);
//double AUDCHF = SymbolInfoDouble("AUDCHF", SYMBOL_ASK);
//double AUDJPY = SymbolInfoDouble("AUDJPY", SYMBOL_ASK);
////Gathers the current NZD Symbol Ask Values
//double NZDUSD = SymbolInfoDouble("NZDUSD", SYMBOL_ASK);
//double NZDCAD = SymbolInfoDouble("NZDCAD", SYMBOL_ASK);
//double NZDCHF = SymbolInfoDouble("NZDCHF", SYMBOL_ASK);
//double NZDJPY = SymbolInfoDouble("NZDJPY", SYMBOL_ASK);
////Gathers the current USD Symbol Ask Values
//double USDCAD = SymbolInfoDouble("USDCAD", SYMBOL_ASK);
//double USDCHF = SymbolInfoDouble("USDCHF", SYMBOL_ASK);
//double USDJPY = SymbolInfoDouble("USDJPY", SYMBOL_ASK);
////Gathers the current CAD Symbol Ask Values
//double CADCHF = SymbolInfoDouble("CADCHF", SYMBOL_ASK);
//double CADJPY = SymbolInfoDouble("CADJPY", SYMBOL_ASK);
////Gathers the current CHF Symbol Ask Values
//double CHFJPY = SymbolInfoDouble("CHFJPY", SYMBOL_ASK);
//
////+------------------------------------------------------------------+
////|          Calculates the percent of change over time              |
////+------------------------------------------------------------------+
//
////calculating the percent change from the past open till the current ask of the EUR values
//
//
//
//
////calculating the percent change from the past open till the current ask of the EUR values
//double perEURGBP = (EURGBP - (lookBackEURGBP + (0.0000000001))/(lookBackEURGBP + (0.0000000001)))*100;
//double perEURAUD = (EURAUD - (lookBackEURAUD + (0.0000000001))/(lookBackEURAUD + (0.0000000001)))*100;
//double perEURNZD = (EURNZD - (lookBackEURNZD + (0.0000000001))/(lookBackEURNZD + (0.0000000001)))*100;
//double perEURUSD = (EURUSD - (lookBackEURUSD + (0.0000000001))/(lookBackEURUSD + (0.0000000001)))*100;
//double perEURCAD = (EURCAD - (lookBackEURCAD + (0.0000000001))/(lookBackEURCAD + (0.0000000001)))*100;
//double perEURCHF = (EURCHF - (lookBackEURCHF + (0.0000000001))/(lookBackEURCHF + (0.0000000001)))*100;
//double perEURJPY = (EURJPY - (lookBackEURJPY + (0.0000000001))/(lookBackEURJPY + (0.0000000001)))*100;
//
////calculating the percent change from the past open till the current ask of the GBP values
//double perGBPAUD = (GBPAUD - (lookBackGBPAUD + (0.0000000001))/(lookBackGBPAUD + (0.0000000001)))*100;
//double perGBPNZD = (GBPNZD - (lookBackGBPNZD + (0.0000000001))/(lookBackGBPNZD + (0.0000000001)))*100;
//double perGBPUSD = (GBPUSD - (lookBackGBPUSD + (0.0000000001))/(lookBackGBPUSD + (0.0000000001)))*100;
//double perGBPCAD = (GBPCAD - (lookBackGBPCAD + (0.0000000001))/(lookBackGBPCAD + (0.0000000001)))*100;
//double perGBPCHF = (GBPCHF - (lookBackGBPCHF + (0.0000000001))/(lookBackGBPCHF + (0.0000000001)))*100;
//double perGBPJPY = (GBPJPY - (lookBackGBPJPY + (0.0000000001))/(lookBackGBPJPY + (0.0000000001)))*100;
//
////calculating the percent change from the past open till the current ask of the AUD values
//double perAUDNZD = (AUDNZD - (lookBackAUDNZD + (0.0000000001))/(lookBackAUDNZD + (0.0000000001)))*100;
//double perAUDUSD = (AUDUSD - (lookBackAUDUSD + (0.0000000001))/(lookBackAUDUSD + (0.0000000001)))*100;
//double perAUDCAD = (AUDCAD - (lookBackAUDCAD + (0.0000000001))/(lookBackAUDCAD + (0.0000000001)))*100;
//double perAUDCHF = (AUDCHF - (lookBackAUDCHF + (0.0000000001))/(lookBackAUDCHF + (0.0000000001)))*100;
//double perAUDJPY = (AUDJPY - (lookBackAUDJPY + (0.0000000001))/(lookBackAUDJPY + (0.0000000001)))*100;
//
////calculating the percent change from the past open till the current ask of the NZD values
//double perNZDUSD = (NZDUSD - (lookBackNZDUSD + (0.0000000001))/(lookBackNZDUSD + (0.0000000001)))*100;
//double perNZDCAD = (NZDCAD - (lookBackNZDCAD + (0.0000000001))/(lookBackNZDCAD + (0.0000000001)))*100;
//double perNZDCHF = (NZDCHF - (lookBackNZDCHF + (0.0000000001))/(lookBackNZDCHF + (0.0000000001)))*100;
//double perNZDJPY = (NZDJPY - (lookBackNZDJPY + (0.0000000001))/(lookBackNZDJPY + (0.0000000001)))*100;
//
////calculating the percent change from the past open till the current ask of the USD values
//double perUSDCAD = (USDCAD - (lookBackUSDCAD + (0.0000000001))/(lookBackUSDCAD + (0.0000000001)))*100;
//double perUSDCHF = (USDCHF - (lookBackUSDCHF + (0.0000000001))/(lookBackUSDCHF + (0.0000000001)))*100;
//double perUSDJPY = (USDJPY - (lookBackUSDJPY + (0.0000000001))/(lookBackUSDJPY + (0.0000000001)))*100;
//
////calculating the percent change from the past open till the current ask of the CAD values
//double perCADCHF = (CADCHF - (lookBackCADCHF + (0.0000000001))/(lookBackCADCHF + (0.0000000001)))*100;
//double perCADJPY = (CADJPY - (lookBackCADJPY + (0.0000000001))/(lookBackCADJPY + (0.0000000001)))*100;
//
////calculating the percent change from the past open till the current ask of the JPY values
//double perCHFJPY = (CHFJPY - (lookBackCHFJPY + (0.0000000001))/(lookBackCHFJPY + (0.0000000001)))*100;
//
////Adds all the percentages from all the pairs together with thier respective pairs
////This gives me the true strength numbers I need to use rather than the close value
////of each candle in the past.
//double perEUR = (perEURGBP + perEURAUD + perEURNZD + perEURUSD + perEURCAD + perEURCHF + perEURJPY);
//double perGBP = ((-perEURGBP) + perGBPAUD + perGBPNZD + perGBPUSD + perGBPCAD + perGBPCHF + perGBPJPY);
//double perAUD = (((-perEURAUD) + (-perGBPAUD)) + perAUDNZD + perAUDUSD + perAUDCAD + perAUDCHF + perAUDJPY);
//double perNZD = (((-perEURNZD) + (-perGBPNZD) + (-perAUDNZD)) + perNZDUSD + perNZDCAD + perNZDCHF + perNZDJPY);
//double perUSD = (((-perEURUSD) + (-perGBPUSD) + (-perAUDUSD) + (-perNZDUSD)) + perUSDCAD + perUSDCHF + perUSDJPY);
//double perCAD = (((-perEURCAD) + (-perGBPCAD) + (-perAUDCAD) + (-perNZDCAD) + (-perUSDCAD)) + perCADCHF + perCADJPY);
//double perCHF = (((-perEURCHF) + (-perGBPCHF) + (-perAUDCHF) + (-perNZDCHF) + (-perUSDCHF) + (-perCADCHF)) + perCHFJPY);
//double perJPY = ((-perEURJPY) + (-perGBPJPY) + (-perAUDJPY) + (-perNZDJPY) + (-perUSDJPY) + (-perCADJPY) + (-perCHFJPY));


//+------------------------------------------------------------------+
//|          Currently printing results to the experts log           |
//+------------------------------------------------------------------+

//   perEUR = NormalizeDouble(perEUR,2);
//   Print("rounded percent of the eur: ",perEUR);
//   perGBP = NormalizeDouble(perGBP,2);
//   Print("rounded percent of the gbp: ",perGBP);
//   perAUD = NormalizeDouble(perAUD,2);
//   Print("rounded percent of the aud: ",perAUD);
//   perNZD = NormalizeDouble(perNZD,2);
//   Print("rounded percent of the nzd: ",perNZD);
//   perUSD = NormalizeDouble(perUSD,2);
//   Print("rounded percent of the usd: ",perUSD);
//   perCAD = NormalizeDouble(perCAD,2);
//   Print("rounded percent of the cad: ",perCAD);
//   perCHF = NormalizeDouble(perCHF,2);
//   Print("rounded percent of the chf: ",perCHF);
//   perJPY = NormalizeDouble(perJPY,2);
//   Print("rounded percent of the jpy: ",perJPY);

//This confirms the percentage math. "Correlation" this should most times be zero it will vary when price first shift
//   Print("Sum of all percent changes: ", perEUR + perGBP + perAUD + perNZD + perUSD + perCAD + perCHF + perJPY);



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int OnInit()
  {
//--- indicator buffers mapping for EUR
   SetIndexBuffer(0,EUR_Band);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"EUR Band: ");

//--- indicator buffers mapping for GBP
   SetIndexBuffer(1,GBP_Band);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"GBP Band: ");

//--- indicator buffers mapping for AUD
   SetIndexBuffer(2,AUD_Band);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"AUD Band: ");

//--- indicator buffers mapping for NZD
   SetIndexBuffer(3,NZD_Band);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"NZD Band: ");

//--- indicator buffers mapping for USD
   SetIndexBuffer(4,USD_Band);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexLabel(4,"USD Band: ");

//--- indicator buffers mapping for CAD
   SetIndexBuffer(5,CAD_Band);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexLabel(5,"CAD Band: ");

//--- indicator buffers mapping for CHF
   SetIndexBuffer(6,CHF_Band);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexLabel(6,"CHF Band: ");

//--- indicator buffers mapping for JPY
   SetIndexBuffer(7,JPY_Band);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexLabel(7,"JPY Band: ");

//--- indicator buffers mapping for buy arrows
   SetIndexBuffer(8,EUR_UpArrow);
   SetIndexStyle(8,DRAW_ARROW);
   SetIndexArrow(8,233);
   SetIndexLabel(8,"Buy Signal");

//--- indicator buffers mapping for sell arrows
   SetIndexBuffer(9,EUR_DownArrow);
   SetIndexStyle(9,DRAW_ARROW);
   SetIndexArrow(9,234);
   SetIndexLabel(9,"Buy Signal");

//---
   return(INIT_SUCCEEDED);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

//looking at older bars
   int counted_bars,limit;
   counted_bars = IndicatorCounted();
   if(!counted_bars)limit = Bars - 2;
   else limit = Bars - counted_bars - 1;

   for(int i=1; i <= limit; i++)
     {
      //Im trying to get the value from My_CSI_Arrow_Calculaor.mq4 for each candle to
      //draw lines in a separate window. That value should be the Strength, in this instance,
      //of the EUR.
      //Why is it returning the same value for evey candle?
      
      //Indicator Lines for the EUR currency strength 
      EUR_Band[i] = iCustom(NULL, PERIOD_M15, "My_CSI_Arrow_Calculator", 0, i);
      Print("This is the icustom result: ",EUR_Band[i]);
      
      //Purchase and sell arrows for the EURGBP pair
      EUR_UpArrow[i] = iCustom(NULL, PERIOD_M15, "My_CSI_Arrow_Calculator", 8, i);
      EUR_DownArrow[i] = iCustom(NULL, PERIOD_M15, "My_CSI_Arrow_Calculator", 9, i);
      
      //Indicator Lines for the GBP
      GBP_Band[i] = iCustom(NULL, PERIOD_M15, "My_CSI_Arrow_Calculator", 1, i);

      
   
//This draws bands correctly but uses the wrong data.    
      //GBP_Band[i] = iRSI("GBPJPY", PERIOD_M15, lookBack, PRICE_CLOSE, i);
      //AUD_Band[i] = iRSI("AUDJPY", PERIOD_M15, lookBack, PRICE_CLOSE, i);
      //NZD_Band[i] = iRSI("NZDJPY", PERIOD_M15, lookBack, PRICE_CLOSE, i);
      //USD_Band[i] = iRSI("USDJPY", PERIOD_M15, lookBack, PRICE_CLOSE, i);
      //CAD_Band[i] = iRSI("CADJPY", PERIOD_M15, lookBack, PRICE_CLOSE, i);
      //CHF_Band[i] = iRSI("CHFJPY", PERIOD_M15, lookBack, PRICE_CLOSE, i);
      //JPY_Band[i] = iRSI("EURUSD", PERIOD_M15, lookBack, PRICE_CLOSE, i);
 
//Settings for the stochastics      
double currentK = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, Slowing, method, 0, MODE_MAIN,i);
double previousK = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, Slowing, method, 0, MODE_MAIN,i+1);
double currentD = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, Slowing, method, 0, MODE_SIGNAL,i);
double previousD = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, Slowing, method, 0, MODE_SIGNAL,i+1);

//+------------------------------------------------------------------+
//|Draw arrows to indicate a purchase or sell signal for the EUR Pairs
//+------------------------------------------------------------------+

//Signals to purchase or sell the EURGBP
   double GbpEurDiff = GBP_Band[i] - EUR_Band[i];  //Check to see if the difference is below zero
      if(GbpEurDiff < 0)
      {     
      GbpEurDiff = -GbpEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[i] > EUR_Band[i] && GbpEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         EUR_UpArrow[i] = Close[i];
         Print("Buy EURGBP");
         Print("gbpEurDiff: ", GbpEurDiff);
        }
        
   double EurGbpDiff = EUR_Band[i] - GBP_Band[i];  //Check to see if the difference is below zero
      if(EurGbpDiff < 0)
      {     
      EurGbpDiff = -EurGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[i] > GBP_Band[i] && EurGbpDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         EUR_DownArrow[i] = Close[i];
         Print("Sell EURGBP");
         Print(EurGbpDiff);
        }
        
//Commented all this out till I can get one line working properly
//and get the arrows showing up where and when they should be        
/*
//Signals to purchase or sell the EURAUD      
   double AudEurDiff = AUD_Band[1] - EUR_Band[1];  //Check to see if the difference is below zero
      if(AudEurDiff < 0)
      {     
      AudEurDiff = -AudEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > EUR_Band[1] && AudEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy EURAUD");
        }
        
   double EurAudDiff = EUR_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(EurAudDiff < 0)
      {     
      EurAudDiff = -EurAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[1] > AUD_Band[1] && EurAudDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURAUD");
        }

//Signals to purchase or sell the EURNZD      
   double NzdEurDiff = NZD_Band[1] - EUR_Band[1];  //Check to see if the difference is below zero
      if(NzdEurDiff < 0)
      {     
      NzdEurDiff = -NzdEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(NZD_Band[1] > EUR_Band[1] && NzdEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy EURNZD");
        }
        
   double EurNzdDiff = EUR_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(EurNzdDiff < 0)
      {     
      EurNzdDiff = -EurNzdDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[1] > NZD_Band[1] && EurNzdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURNZD");
        }

//Signals to purchase or sell the EURUSD      
   double UsdEurDiff = USD_Band[1] - EUR_Band[1];  //Check to see if the difference is below zero
      if(UsdEurDiff < 0)
      {     
      UsdEurDiff = -UsdEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > EUR_Band[1] && UsdEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy EURUSD");
        }
        
   double EurUsdDiff = EUR_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(EurNzdDiff < 0)
      {     
      EurUsdDiff = -EurUsdDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[1] > USD_Band[1] && EurUsdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURUSD");
        }

//Signals to purchase or sell the EURCAD      
   double CadEurDiff = CAD_Band[1] - EUR_Band[1];  //Check to see if the difference is below zero
      if(CadEurDiff < 0)
      {     
      CadEurDiff = -CadEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > EUR_Band[1] && CadEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy EURCAD");
        }
        
   double EurCadDiff = EUR_Band[1] - CAD_Band[1];  //Check to see if the difference is below zero
      if(EurCadDiff < 0)
      {     
      EurCadDiff = -EurCadDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[1] > USD_Band[1] && EurCadDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURCAD");
        }

//Signals to purchase or sell the EURCHF      
   double ChfEurDiff = CHF_Band[1] - EUR_Band[1];  //Check to see if the difference is below zero
      if(ChfEurDiff < 0)
      {     
      ChfEurDiff = -ChfEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > EUR_Band[1] && ChfEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy EURCHF");
        }
        
   double EurChfDiff = EUR_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(EurChfDiff < 0)
      {     
      EurChfDiff = -EurChfDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[1] > USD_Band[1] && EurChfDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURCHF");
        }

//Signals to purchase or sell the EURJPY      
   double JpyEurDiff = JPY_Band[1] - EUR_Band[1];  //Check to see if the difference is below zero
      if(JpyEurDiff < 0)
      {     
      JpyEurDiff = -JpyEurDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > EUR_Band[1] && JpyEurDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy EURJPY");
        }
        
   double EurJpyDiff = EUR_Band[1] - JPY_Band[1];  //Check to see if the difference is below zero
      if(EurJpyDiff < 0)
      {     
      EurJpyDiff = -EurJpyDiff; //if its below zero invert the negative to positive 
      }
      
      if(EUR_Band[1] > USD_Band[1] && EurJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURJPY");
        }
        
        
//+------------------------------------------------------------------+
//Draw arrows to indicate a purchase or sell signal for the GBP pairs 
//+------------------------------------------------------------------+

//Signals to purchase or sell the GBPAUD      
   double AudGbpDiff = AUD_Band[1] - GBP_Band[1];  //Check to see if the difference is below zero
      if(AudGbpDiff < 0)
      {     
      AudGbpDiff = -AudGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > GBP_Band[1] && AudGbpDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy GBPAUD");
        }
        
   double GbpAudDiff = GBP_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(GbpAudDiff < 0)
      {     
      GbpAudDiff = -GbpAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[1] > AUD_Band[1] && GbpAudDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell GBPAUD");
        }

//Signals to purchase or sell the GBPNZD      
   double NzdGbpDiff = NZD_Band[1] - GBP_Band[1];  //Check to see if the difference is below zero
      if(NzdGbpDiff < 0)
      {     
      NzdGbpDiff = -NzdGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(NZD_Band[1] > GBP_Band[1] && NzdGbpDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy GBPNZD");
        }
        
   double GbpNzdDiff = GBP_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(GbpNzdDiff < 0)
      {     
      GbpNzdDiff = -GbpNzdDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[1] > NZD_Band[1] && GbpNzdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell GBPNZD");
        }

//Signals to purchase or sell the GBPUSD      
   double UsdGbpDiff = USD_Band[1] - GBP_Band[1];  //Check to see if the difference is below zero
      if(UsdGbpDiff < 0)
      {     
      UsdGbpDiff = -UsdGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > GBP_Band[1] && UsdGbpDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy GBPUSD");
        }
        
   double GbpUsdDiff = GBP_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(GbpUsdDiff < 0)
      {     
      GbpUsdDiff = -GbpUsdDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[1] > USD_Band[1] && GbpUsdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell GBPUSD");
        }

//Signals to purchase or sell the GBPCAD      
   double CadGbpDiff = CAD_Band[1] - GBP_Band[1];  //Check to see if the difference is below zero
      if(CadGbpDiff < 0)
      {     
      CadGbpDiff = -CadGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > GBP_Band[1] && CadGbpDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy GBPCAD");
        }
        
   double GbpCadDiff = GBP_Band[1] - CAD_Band[1];  //Check to see if the difference is below zero
      if(GbpCadDiff < 0)
      {     
      GbpCadDiff = -GbpCadDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[1] > USD_Band[1] && GbpCadDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell GBPCAD");
        }

//Signals to purchase or sell the GBPCHF      
   double ChfGbpDiff = CHF_Band[1] - GBP_Band[1];  //Check to see if the difference is below zero
      if(ChfGbpDiff < 0)
      {     
      ChfGbpDiff = -ChfGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > GBP_Band[1] && ChfGbpDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy GBPCHF");
        }
        
   double GbpChfDiff = GBP_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(GbpChfDiff < 0)
      {     
      GbpChfDiff = -GbpChfDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[1] > USD_Band[1] && GbpChfDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell EURCHF");
        }

//Signals to purchase or sell the GBPJPY      
   double JpyGbpDiff = JPY_Band[1] - GBP_Band[1];  //Check to see if the difference is below zero
      if(JpyGbpDiff < 0)
      {     
      JpyGbpDiff = -JpyGbpDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > GBP_Band[1] && JpyGbpDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy GBPJPY");
        }
        
   double GbpJpyDiff = GBP_Band[1] - JPY_Band[1];  //Check to see if the difference is below zero
      if(GbpJpyDiff < 0)
      {     
      GbpJpyDiff = -GbpJpyDiff; //if its below zero invert the negative to positive 
      }
      
      if(GBP_Band[1] > USD_Band[1] && GbpJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell GBPJPY");
        }
        
        
//+------------------------------------------------------------------+
//Draw arrows to indicate a purchase or sell signal for the AUD pairs 
//+------------------------------------------------------------------+

//Signals to purchase or sell the AUDNZD      
   double NzdAudDiff = NZD_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(NzdAudDiff < 0)
      {     
      NzdAudDiff = -NzdAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(NZD_Band[1] > AUD_Band[1] && NzdAudDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy AUDNZD");
        }
        
   double AudNzdDiff = AUD_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(AudNzdDiff < 0)
      {     
      AudNzdDiff = -AudNzdDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > NZD_Band[1] && AudNzdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell AUDNZD");
        }


//Signals to purchase or sell the AUDUSD      
   double UsdAudDiff = USD_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(UsdAudDiff < 0)
      {     
      UsdAudDiff = -UsdAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > AUD_Band[1] && UsdAudDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy AUDUSD");
        }
        
   double AudUsdDiff = AUD_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(AudUsdDiff < 0)
      {     
      AudUsdDiff = -AudUsdDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > USD_Band[1] && AudUsdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell AUDUSD");
        }

//Signals to purchase or sell the AUDCAD      
   double CadAudDiff = CAD_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(CadAudDiff < 0)
      {     
      CadAudDiff = -CadAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > AUD_Band[1] && CadAudDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy AUDCAD");
        }
        
   double AudCadDiff = AUD_Band[1] - CAD_Band[1];  //Check to see if the difference is below zero
      if(AudCadDiff < 0)
      {     
      AudCadDiff = -AudCadDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > USD_Band[1] && AudCadDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell GBPCAD");
        }

      //Signals to purchase or sell the AUDCHF      
   double ChfAudDiff = CHF_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(ChfAudDiff < 0)
      {     
      ChfAudDiff = -ChfAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > AUD_Band[1] && ChfAudDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy AUDCHF");
        }
        
   double AudChfDiff = AUD_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(AudChfDiff < 0)
      {     
      AudChfDiff = -AudChfDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > USD_Band[1] && AudChfDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell AUDCHF");
        }

//Signals to purchase or sell the AUDJPY   
   double JpyAudDiff = JPY_Band[1] - AUD_Band[1];  //Check to see if the difference is below zero
      if(JpyAudDiff < 0)
      {     
      JpyAudDiff = -JpyAudDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > AUD_Band[1] && JpyAudDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy AUDJPY");
        }
        
   double AudJpyDiff = AUD_Band[1] - JPY_Band[1];  //Check to see if the difference is below zero
      if(AudJpyDiff < 0)
      {     
      AudJpyDiff = -AudJpyDiff; //if its below zero invert the negative to positive 
      }
      
      if(AUD_Band[1] > USD_Band[1] && AudJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell AUDJPY");
        }

        
        
//+------------------------------------------------------------------+
//Draw arrows to indicate a purchase or sell signal for the NZD pairs 
//+------------------------------------------------------------------+

//Signals to purchase or sell the NZDUSD      
   double UsdNzdDiff = USD_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(UsdNzdDiff < 0)
      {     
      UsdNzdDiff = -UsdNzdDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > NZD_Band[1] && UsdNzdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy NZDUSD");
        }
        
   double NzdUsdDiff = NZD_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(NzdUsdDiff < 0)
      {     
      NzdUsdDiff = -NzdUsdDiff; //if its below zero invert the negative to positive 
      }
      
      if(NZD_Band[1] > USD_Band[1] && NzdUsdDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell NZDUSD");
        }

//Signals to purchase or sell the NZDCAD      
   double CadNzdDiff = CAD_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(CadNzdDiff < 0)
      {     
      CadNzdDiff = -CadNzdDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > NZD_Band[1] && CadNzdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy NZDCAD");
        }
        
   double NzdCadDiff = NZD_Band[1] - CAD_Band[1];  //Check to see if the difference is below zero
      if(NzdCadDiff < 0)
      {     
      NzdCadDiff = -NzdCadDiff; //if its below zero invert the negative to positive 
      }
      
      if(NZD_Band[1] > USD_Band[1] && NzdCadDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell NZDCAD");
        }

//Signals to purchase or sell the NZDCHF      
   double ChfNzdDiff = CHF_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(ChfNzdDiff < 0)
      {     
      ChfNzdDiff = -ChfNzdDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > AUD_Band[1] && ChfNzdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy NZDCHF");
        }
        
   double NzdChfDiff = NZD_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(NzdChfDiff < 0)
      {     
      NzdChfDiff = -NzdChfDiff; //if its below zero invert the negative to positive 
      }
      
      if(NZD_Band[1] > USD_Band[1] && NzdChfDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell NZDCHF");
        }

//Signals to purchase or sell the NZDJPY     
      double JpyNzdDiff = JPY_Band[1] - NZD_Band[1];  //Check to see if the difference is below zero
      if(JpyNzdDiff < 0)
      {     
      JpyNzdDiff = -JpyNzdDiff; //if its below zero invert the negative to positive 
      }     
            
      if(USD_Band[1] > NZD_Band[1] && JpyNzdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy NZDJPY");
        }
       
      double NzdJpyDiff = NZD_Band[1] - JPY_Band[1]; //Check to see if the difference is below zero 
      if(NzdJpyDiff < 0)
      {
      NzdJpyDiff = -NzdJpyDiff; //if its below zero invert the negative to positive
      }
      
      if(USD_Band[1] > NZD_Band[1] && NzdJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell NZDJPY");
        }
        
        
//+------------------------------------------------------------------+
//Draw arrows to indicate a purchase or sell signal for the USD pairs 
//+------------------------------------------------------------------+

//Signals to purchase or sell the USDCAD      
   double CadUsdDiff = CAD_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(CadUsdDiff < 0)
      {     
      CadUsdDiff = -CadUsdDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > USD_Band[1] && CadUsdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy USDCAD");
        }
        
   double UsdCadDiff = USD_Band[1] - CAD_Band[1];  //Check to see if the difference is below zero
      if(UsdCadDiff < 0)
      {     
      UsdCadDiff = -UsdCadDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > USD_Band[1] && UsdCadDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell USDCAD");
        }

//Signals to purchase or sell the USDCHF      
   double ChfUsdDiff = CHF_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(ChfUsdDiff < 0)
      {     
      ChfUsdDiff = -ChfUsdDiff; //if its below zero invert the negative to positive 
      }
      
      if(CHF_Band[1] > USD_Band[1] && ChfUsdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy USDCHF");
        }
        
   double UsdChfDiff = USD_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(UsdChfDiff < 0)
      {     
      UsdChfDiff = -UsdChfDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > CHF_Band[1] && UsdChfDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell USDCHF");
        }

//Signals to purchase or sell the USDJPY      
      double JpyUsdDiff = JPY_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(JpyUsdDiff < 0)
      {     
      JpyUsdDiff = -JpyUsdDiff; //if its below zero invert the negative to positive 
      }     
            
      if(JPY_Band[1] > USD_Band[1] && JpyUsdDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy USDJPY");
        }
       
      double UsdJpyDiff = USD_Band[1] - JPY_Band[1]; //Check to see if the difference is below zero 
      if(UsdJpyDiff < 0)
      {
      UsdJpyDiff = -UsdJpyDiff; //if its below zero invert the negative to positive
      }
      
      if(USD_Band[1] > JPY_Band[1] && UsdJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell USDJPY");
        }
        
        
//+------------------------------------------------------------------+
//Draw arrows to indicate a purchase or sell signal for the CAD pairs 
//+------------------------------------------------------------------+

//Signals to purchase or sell the CADCHF      
   double ChfCadDiff = CHF_Band[1] - CAD_Band[1];  //Check to see if the difference is below zero
      if(ChfCadDiff < 0)
      {     
      ChfCadDiff = -ChfCadDiff; //if its below zero invert the negative to positive 
      }
      
      if(USD_Band[1] > CAD_Band[1] && ChfCadDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy CADCHF");
        }

   double CadChfDiff = CAD_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(CadChfDiff < 0)
      {     
      CadChfDiff = -CadChfDiff; //if its below zero invert the negative to positive 
      }
      
      if(CAD_Band[1] > USD_Band[1] && CadChfDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell CADCHF");
        }

//Signals to purchase or sell the CADJPY      
   double JpyCadDiff = JPY_Band[1] - USD_Band[1];  //Check to see if the difference is below zero
      if(JpyCadDiff < 0)
      {     
      JpyCadDiff = -JpyCadDiff; //if its below zero invert the negative to positive 
      }     
            
      if(JPY_Band[1] > CAD_Band[1] && JpyCadDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy CADJPY");
        }
       
   double CadJpyDiff = CAD_Band[1] - JPY_Band[1]; //Check to see if the difference is below zero 
      if(CadJpyDiff < 0)
      {
      CadJpyDiff = -CadJpyDiff; //if its below zero invert the negative to positive
      }
      
      if(CAD_Band[1] > JPY_Band[1] && CadJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell CADJPY");
        }
        
        
//+------------------------------------------------------------------+
//Draw arrows to indicate a purchase or sell signal for the CHF pairs 
//+------------------------------------------------------------------+

      //Signals to purchase or sell the CHFJPY      
      double JpyChfDiff = JPY_Band[1] - CHF_Band[1];  //Check to see if the difference is below zero
      if(JpyChfDiff < 0)
      {     
      JpyChfDiff = -JpyChfDiff; //if its below zero invert the negative to positive       
      }                
      if(JPY_Band[1] > CHF_Band[1] && JpyChfDiff > gap && Close[i+1] < previousK < previousD && currentK > currentD && currentD < 20)
        {
         uparrow[i] = Close[i];
         Print("Buy CHFJPY");
        }
       
      double ChfJpyDiff = CHF_Band[1] - JPY_Band[1]; //Check to see if the difference is below zero 
      if(ChfJpyDiff < 0)
      {
      ChfJpyDiff = -ChfJpyDiff; //if its below zero invert the negative to positive
      }
      if(CHF_Band[1] > JPY_Band[1] && ChfJpyDiff > gap && Close[i+1] > previousK  >previousD && currentK < currentD && currentD > 80)
        {
         downarrow[i] = Close[i];
         Print("Sell CHFJPY");
        }
        */
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
